class Manager:

    def __init__ ( self, port ):
        self._sessions = {}
        self._newclientconn = []
        self._newclientaddr = []
        self._newclientmsg  = []    
        self._lock = Lock()
        self._port = port
        
    def acceptclient ( self, conn, addr ):
        msg = Message ( conn )
        command = msg.getcommand()
        
        if command == "DESCRIBE":
            url = msg.getargs()[0]
            
            # url = rtsp://asli.stanford.edu:5982/getstream?rtsp://fable10.stanford.edu:5982/getstream?rtsp://hake.stanford.edu:5982/broadcast
            # site = asli.stanford.edu
            # parent = rtsp://fable10.stanford.edu:5982/getstream
            # source = rtsp://hake.stanford.edu:5982/broadcast
            parsed_url = urlparse.urlparse( url, "rtsp" )
            site = parsed_url[1]
            if string.find( parsed_url[4], "?") >= 0:
                parent, target = string.split( parsed_url[4], "?")
            else:
                target = parsed_url[4]
                parent = target

            # Get the client port from the DESCRIBE request
            cPort = "%s" %msg.getheader("port")
            type = "%s" %msg.getheader("user-agent")
            
            self._lock.acquire()
            if self._sessions.has_key( target ):
                debug("MANAGER: Adding new client")
                ( session, addlock, dellock ) = self._sessions[target]
                addlock.acquire()
                session._newclientconn.append(conn)
                session._newclientaddr.append(addr)
                session._newclientport.append(cPort)
                session._newclienttype.append(type)
                session._newclientmsg.append(msg)
                addlock.release()
            else:
                debug("MANAGER: Starting new Session")
                addlock = Lock()
                dellock = Lock()
                killlock = Lock()
                port = self._port
                session = Session( url, addlock, dellock, self, port, target, killlock )
                self._sessions[target] = (session, addlock, dellock)
                session.start()
                debug("MANAGER: Adding new client")
                addlock.acquire()
                session._newclientconn.append(conn)
                session._newclientaddr.append(addr)
                session._newclientport.append(cPort)
                session._newclienttype.append(type)
                session._newclientmsg.append(msg)
                addlock.release()
                debug("MANAGER: Added new client")
            self._lock.release()

    def delsession( self, target ):
        self._lock.acquire()
        debug ("MANAGER: Killing session")
        if self._sessions.has_key( target ):
            del self._sessions[target]
        self._lock.release()

    def die( self ):
        for k in self._sessions.keys():
            (session, addlock, dellock) = self._sessions[k]
            session._killlock.acquire()
            session._die = 1
            session._killlock.release()
            while (session._amDead == 0):
                i = 0;
            
