class Logger:

    def __init__( self, file = sys.stderr ):
        self._lastmsg = ''
        self._first = 1
        self._repeats = 0
        self._file = file
        self._file.write( "[log started]" )
        self._lock = Lock()
    
    def log( self, msg ):
        self._lock.acquire()
        if msg == self._lastmsg:
            if self._repeats == 0:
                self._file.write( ' (.' )
            self._file.write( '.' )
            self._repeats = self._repeats + 1
        else:
            if self._repeats > 0:
                self._file.write( ')' )
            self._file.write( '\n' )
            self._first = 0
            self._file.write( msg )
            self._repeats = 0
        self._file.flush()
        if self._repeats == 75 - len(msg):
            self._lastmsg = ''
        else:
            self._lastmsg = msg
        self._lock.release()
