"""
PeerCast by
Hrishikesh Deshpande
Mayank Bawa
"""

import sys
import string
import re
import time
import random
import binascii
from threading import *
import copy

from socket import *
if not globals().has_key('IPPROTO_TCP'):
    IPPROTO_TCP = 6

from select import *

import urlparse
try:
    if "rtsp" not in urlparse.uses_netloc:
        urlparse.uses_netloc.append("rtsp")
except:
    pass

execfile("Utils.py")
execfile("Logger.py")
execfile("Listener.py")
execfile("Message.py")
execfile("Forwarder.py")
execfile("Session.py")
execfile("Manager.py")

logger = Logger()
debug = logger.log

def main( argv ):
    # Manager is the co-ordinator for each machine
    port = int(argv[1])
    manager = Manager(port)

    # Wait for clients to make requests
    listener = Listener( port )
    debug( "waiting for a client" )
    try:
        while 1:
            listener.waitforclient(manager)

    finally:
        print "Interrupt received. Dying."
        listener.stop()
        manager.die()


if __name__ == "__main__":


